#include  "E2_lib.h"

#define   NBG1_CEL_ADR    (VDP2_VRAM_A1 + 0x00000)
#define   NBG1_COL_ADR    (VDP2_COLRAM  + 0x00200)

#define   total_images    8

void ss_main()
{
 int temp1;

 slInitSystem(TV_320x240, IMAGE2D_texture, 1);
 slPrint("E2SR1A - Example 05:",  slLocate(2, 5));
 slPrint("Paletted Advanced Sprite Example", slLocate(2, 6));
 e2_BACKCOLOR_setup(10, 10, 0);

 slColRAMMode(CRM16_1024);
 e2_PALETTE2D_load_from_CDROM(0, "son_pals.txt"); slPrint("PAL  Okay!!", slLocate(2, 8));
 e2_PALETTE2D_load_from_CDROM(1, "bmp_pal.txt");  slPrint("PAL  Okay!!", slLocate(2, 10));
 e2_PALETTE2D_set_transparent_color(0, 255);
 e2_PALETTE2D_load_into_COLORRAM(0, VDP2_COLRAM, 256);
 e2_PALETTE2D_load_into_COLORRAM(1, NBG1_COL_ADR, 256);

 e2_IMAGE2D_PAL_load_from_CDROM(0, "son_imgs.txt"); slPrint("IMGS Okay!!", slLocate(2, 9));
 e2_IMAGE2D_PAL_load_from_CDROM(total_images, "son_bmp.txt"); slPrint("BMP  Okay!!", slLocate(2, 11));
 e2_IMAGE2D_PAL_offset_colors(0, total_images, 1);
 for(temp1 = 0; temp1 != total_images + 1; temp1++)
  e2_IMAGE2D_PAL_load_into_SPRITEVRAM(temp1, IMAGE2D_memory_address, 0);
 e2_IMAGE2D_setup(total_images + 1);

 e2_BITMAP2D_setup(8, 1, 0, 0, 1, 0, NBG1_CEL_ADR);
 slScrPosNbg1(toFIXED(0.0), toFIXED(0.0));
 slScrTransparent(NBG1ON);
 slScrAutoDisp(NBG0ON | NBG1ON);

 e2_SPRITE2D_ANIMATION_FRAME_reallocate(0, 1);
 e2_SPRITE2D_ANIMATION_FRAME_reallocate_frame(0, 8);
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 0, 0, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 1, 1, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 2, 2, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 3, 3, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 4, 4, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 5, 5, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 6, 6, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 7, 7, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));

 e2_SPRITE2D_ANIMATION_MOVEMENT_reallocate(0, 1);
 e2_SPRITE2D_ANIMATION_MOVEMENT_reallocate_frame(0, 3);
 e2_SPRITE2D_ANIMATION_MOVEMENT_setup(0, 0, 160, 0, 0, toFIXED( 1.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_MOVEMENT_setup(0, 1, 320, 0, 0, toFIXED(-1.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_MOVEMENT_setup(0, 2, 160, 0, 0, toFIXED( 1.0), toFIXED(0.0), toFIXED(0.0));

 e2_SPRITE2D_ANIMATION_ROTATION_reallocate(0, 1);
 e2_SPRITE2D_ANIMATION_ROTATION_reallocate_frame(0, 2);
 e2_SPRITE2D_ANIMATION_ROTATION_setup(0, 0, 360, DEGtoANG( 1.0));
 e2_SPRITE2D_ANIMATION_ROTATION_setup(0, 1, 360, DEGtoANG(-1.0));

 e2_SPRITE2D_ANIMATION_SCALING_reallocate(0, 1);
 e2_SPRITE2D_ANIMATION_SCALING_reallocate_frame(0, 3);
 e2_SPRITE2D_ANIMATION_SCALING_setup(0, 0, 10, toFIXED( 0.05));
 e2_SPRITE2D_ANIMATION_SCALING_setup(0, 1, 20, toFIXED(-0.05));
 e2_SPRITE2D_ANIMATION_SCALING_setup(0, 2, 10, toFIXED( 0.05));

 e2_SPRITE2D_PAL_ADVANCED_reallocate(1);
 e2_SPRITE2D_PAL_ADVANCED_setup(0, YES, toFIXED(0.0), toFIXED(0.0), toFIXED(200.0), DEGtoANG(0.0), toFIXED(1.0), NO, YES, toFIXED(-160.0), toFIXED(160.0), toFIXED(-120.0), toFIXED(120.0), toFIXED(100.0), toFIXED(400.0), sprite_H_flip, (Uint16)VDP2_COLRAM, palette_256_colors);
 e2_SPRITE2D_PAL_ADVANCED_setup_ANIMATION_FRAME(0, YES, YES, 0, 0, 0);
 e2_SPRITE2D_PAL_ADVANCED_setup_ANIMATION_MOVEMENT(0, YES, YES, 0, 0, 0, 0, 0);
 e2_SPRITE2D_PAL_ADVANCED_setup_ANIMATION_ROTATION(0, YES, YES, 0, 0, 0);
 e2_SPRITE2D_PAL_ADVANCED_setup_ANIMATION_SCALING(0, YES, YES, 0, 0, 0);

 while(-1)
 {
  e2_CONTROLPAD_check_buttons(CONTROLPAD_1);
   switch(CONTROLPAD_button[CONTROLPAD_u_button]){case YES: pSPRITE2D_PAL_ADVANCED[0].position[Y] -= toFIXED(1.0); break;}
   switch(CONTROLPAD_button[CONTROLPAD_d_button]){case YES: pSPRITE2D_PAL_ADVANCED[0].position[Y] += toFIXED(1.0); break;}
   switch(CONTROLPAD_button[CONTROLPAD_l_button]){case YES: pSPRITE2D_PAL_ADVANCED[0].position[X] -= toFIXED(1.0); break;}
   switch(CONTROLPAD_button[CONTROLPAD_r_button]){case YES: pSPRITE2D_PAL_ADVANCED[0].position[X] += toFIXED(1.0); break;}

  e2_SPRITE2D_PAL_ADVANCED_animate(0);
  slSynch();
 }
}
