#include  "E2_lib.h"

#define   NBG1_CEL_ADR    (VDP2_VRAM_A1 + 0x00000)
#define   NBG1_COL_ADR    (VDP2_COLRAM  + 0x00200)

#define   total_images  8
#define   total_sprites 200

void ss_main()
{
 int temp1;

 slInitSystem(TV_320x240, IMAGE2D_texture, 1);
 slPrint("E2SR1A - Example 08:",  slLocate(2, 5));
 slPrint("32K Advanced Sprite Example", slLocate(2, 6));
 e2_BACKCOLOR_setup(0, 5, 5);

 e2_PALETTE2D_load_from_CDROM(  0, "bmp_pal.txt");
 e2_IMAGE2D_PAL_load_from_CDROM(0, "bmp_img.txt");

 e2_IMAGE2D_32K_load_from_CDROM(0, "sonic_00.txt");
 for(temp1 = 0; temp1 != total_images; temp1++)
  e2_IMAGE2D_32K_load_into_SPRITEVRAM(temp1, IMAGE2D_memory_address, 0);
 e2_IMAGE2D_setup(total_images);

 e2_PALETTE2D_load_into_COLORRAM(0, NBG1_COL_ADR, 256);
 e2_BITMAP2D_setup(0, 1, 0, 0, 1, 0, NBG1_CEL_ADR);
 slScrPosNbg1(toFIXED(0.0), toFIXED(0.0));
 slScrTransparent(NBG1ON);
 slScrAutoDisp(NBG0ON | NBG1ON);

 e2_SPRITE2D_ANIMATION_FRAME_reallocate(0, 1);
 e2_SPRITE2D_ANIMATION_FRAME_reallocate_frame(0, 8);
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 0, 0, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 1, 1, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 2, 2, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 3, 3, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 4, 4, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 5, 5, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 6, 6, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_FRAME_setup(0, 7, 7, 5, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0));

 e2_SPRITE2D_ANIMATION_MOVEMENT_reallocate(0, 1);
 e2_SPRITE2D_ANIMATION_MOVEMENT_reallocate_frame(0, 2);
 e2_SPRITE2D_ANIMATION_MOVEMENT_setup(0, 0, 320, 0, 0, toFIXED( 1.0), toFIXED(0.0), toFIXED(0.0));
 e2_SPRITE2D_ANIMATION_MOVEMENT_setup(0, 1, 320, 0, 0, toFIXED(-1.0), toFIXED(0.0), toFIXED(0.0));

 e2_SPRITE2D_32K_ADVANCED_reallocate(total_sprites);
 for(temp1 = 0; temp1 != total_sprites; temp1++)
 {
  e2_SPRITE2D_32K_ADVANCED_setup(temp1, YES, toFIXED(-160.0) + (temp1 * toFIXED(15.0)), toFIXED(120.0), toFIXED(50.0) + (temp1 * toFIXED(15.0)), DEGtoANG(0.0), toFIXED(1.0), YES, NO, toFIXED(0.0), toFIXED(0.0), toFIXED(0.0), toFIXED(0.0), toFIXED(0.0), toFIXED(0.0), sprite_H_flip);
  e2_SPRITE2D_32K_ADVANCED_setup_ANIMATION_FRAME(   temp1, YES, YES, 0, 0, 0);
  e2_SPRITE2D_32K_ADVANCED_setup_ANIMATION_MOVEMENT(temp1, YES, YES, 0, 0, 0, 0, 0);
  e2_SPRITE2D_32K_ADVANCED_setup_ANIMATION_ROTATION(temp1, NO, NO, NONE, 0, 0);
  e2_SPRITE2D_32K_ADVANCED_setup_ANIMATION_SCALING( temp1, NO, NO, NONE, 0, 0);
 }

 while(-1)
 {
  e2_CONTROLPAD_check_buttons(CONTROLPAD_1);
   switch(CONTROLPAD_button[CONTROLPAD_u_button]){case YES: for(temp1 = 0; temp1 != total_sprites; temp1++) pSPRITE2D_32K_ADVANCED[temp1].position[Y] -= toFIXED(1.0); break;}
   switch(CONTROLPAD_button[CONTROLPAD_d_button]){case YES: for(temp1 = 0; temp1 != total_sprites; temp1++) pSPRITE2D_32K_ADVANCED[temp1].position[Y] += toFIXED(1.0); break;}
   switch(CONTROLPAD_button[CONTROLPAD_l_button]){case YES: for(temp1 = 0; temp1 != total_sprites; temp1++) pSPRITE2D_32K_ADVANCED[temp1].position[X] -= toFIXED(1.0); break;}
   switch(CONTROLPAD_button[CONTROLPAD_r_button]){case YES: for(temp1 = 0; temp1 != total_sprites; temp1++) pSPRITE2D_32K_ADVANCED[temp1].position[X] += toFIXED(1.0); break;}

  for(temp1 = 0; temp1 != total_sprites; temp1++)
   e2_SPRITE2D_32K_ADVANCED_animate(temp1);
  slSynch();
 }
}
