#include  "E2_lib.h"

#define   CHECK_PORT      CONTROLPORT_1  // Change this to 'CONTROLPORT_2' to check out 2p's port instead.

void erase_screen()
{
 slPrint("                             ", slLocate(2,  7));
 slPrint("U :                          ", slLocate(2,  8));
 slPrint("D :                          ", slLocate(2,  9));
 slPrint("R :                          ", slLocate(2, 10));
 slPrint("L :                          ", slLocate(2, 11));
 slPrint("A :                          ", slLocate(2, 12));
 slPrint("B :                          ", slLocate(2, 13));
 slPrint("C :                          ", slLocate(2, 14));
 slPrint("S :                          ", slLocate(2, 15));
 slPrint("X :                          ", slLocate(2, 16));
 slPrint("Y :                          ", slLocate(2, 17));
 slPrint("Z :                          ", slLocate(2, 18));
 slPrint("TR:                          ", slLocate(2, 19));
 slPrint("TL:                          ", slLocate(2, 20));
 slPrint("X :                          ", slLocate(2, 22));
 slPrint("Y :                          ", slLocate(2, 23));
 slPrint("Z :                          ", slLocate(2, 24));
}

void ss_main()
{
 slInitSystem(TV_320x240, IMAGE2D_texture, 1);
 slPrint("E2SR1A - Example 00:", slLocate(2, 2));
 slPrint("Controlpad Checker",  slLocate(2, 3));

 if(CHECK_PORT == CONTROLPORT_1) slPrint("[1P Control Port]", slLocate(2, 5));
 if(CHECK_PORT == CONTROLPORT_2) slPrint("[2P Control Port]", slLocate(2, 5));

 while(-1)
 {
  erase_screen();
  switch(e2_PERIPHERAL_check_whats_connected(CHECK_PORT))
  {
   case PERIPHERAL_NONE:
    slPrint("PERIPHERAL_NONE              ", slLocate(2,  7));
    break;

   case PERIPHERAL_CONTROLPAD_DIGITAL:
    slPrint("PERIPHERAL_CONTROLPAD_DIGITAL", slLocate(2,  7));
    e2_CONTROLPAD_check_buttons(CHECK_PORT);
    break;

   case PERIPHERAL_CONTROLPAD_ANALOG:
    slPrint("PERIPHERAL_CONTROLPAD_ANALOG", slLocate(2,  7));
    e2_CONTROLPAD_check_buttons(CHECK_PORT);
    break;
  }
  if(CONTROLPAD_button[CONTROLPAD_u_button]  == YES) slPrint("YES", slLocate(7,  8)); else slPrint("NO", slLocate(7,  8));
  if(CONTROLPAD_button[CONTROLPAD_d_button]  == YES) slPrint("YES", slLocate(7,  9)); else slPrint("NO", slLocate(7,  9));
  if(CONTROLPAD_button[CONTROLPAD_r_button]  == YES) slPrint("YES", slLocate(7, 10)); else slPrint("NO", slLocate(7, 10));
  if(CONTROLPAD_button[CONTROLPAD_l_button]  == YES) slPrint("YES", slLocate(7, 11)); else slPrint("NO", slLocate(7, 11));
  if(CONTROLPAD_button[CONTROLPAD_a_button]  == YES) slPrint("YES", slLocate(7, 12)); else slPrint("NO", slLocate(7, 12));
  if(CONTROLPAD_button[CONTROLPAD_b_button]  == YES) slPrint("YES", slLocate(7, 13)); else slPrint("NO", slLocate(7, 13));
  if(CONTROLPAD_button[CONTROLPAD_c_button]  == YES) slPrint("YES", slLocate(7, 14)); else slPrint("NO", slLocate(7, 14));
  if(CONTROLPAD_button[CONTROLPAD_s_button]  == YES) slPrint("YES", slLocate(7, 15)); else slPrint("NO", slLocate(7, 15));
  if(CONTROLPAD_button[CONTROLPAD_x_button]  == YES) slPrint("YES", slLocate(7, 16)); else slPrint("NO", slLocate(7, 16));
  if(CONTROLPAD_button[CONTROLPAD_y_button]  == YES) slPrint("YES", slLocate(7, 17)); else slPrint("NO", slLocate(7, 17));
  if(CONTROLPAD_button[CONTROLPAD_z_button]  == YES) slPrint("YES", slLocate(7, 18)); else slPrint("NO", slLocate(7, 18));
  if(CONTROLPAD_button[CONTROLPAD_tr_button] == YES) slPrint("YES", slLocate(7, 19)); else slPrint("NO", slLocate(7, 19));
  if(CONTROLPAD_button[CONTROLPAD_tl_button] == YES) slPrint("YES", slLocate(7, 20)); else slPrint("NO", slLocate(7, 20));
  slPrintFX(toFIXED(CONTROLPAD_analog_x), slLocate(7, 22));
  slPrintFX(toFIXED(CONTROLPAD_analog_y), slLocate(7, 23));
  slPrintFX(toFIXED(CONTROLPAD_analog_z), slLocate(7, 24));
  slSynch();
 }
}
