#include  "E2_lib.h"

#define   NBG1_CEL_ADR    (VDP2_VRAM_A1 + 0x00000)
#define   NBG1_COL_ADR    (VDP2_COLRAM  + 0x00200)

void ss_main()
{
 slInitSystem(TV_320x240, IMAGE2D_texture, 1);
 slPrint("E2SR1A - Example 02:", slLocate(2, 5));
 slPrint("Fade Example",  slLocate(2, 6));

// [You can delete this block if you want...it just shows a bitmap]
 slColRAMMode(CRM16_1024);
 e2_IMAGE2D_PAL_load_from_CDROM(0, "kim_bmp.txt"); slPrint("BMP Okay!!", slLocate(2, 8));
 e2_PALETTE2D_load_from_CDROM(  0, "kim_pal.txt"); slPrint("PAL Okay!!", slLocate(2, 9));

 e2_PALETTE2D_load_into_COLORRAM(0, NBG1_COL_ADR, 256);
 e2_BITMAP2D_setup(0, 1, 0, 0, 1, 0, NBG1_CEL_ADR);
 slScrPosNbg1(toFIXED(0.0), toFIXED(0.0));
 slScrTransparent(NBG1ON);
 slScrAutoDisp(NBG0ON | NBG1ON);
// [End of Bitmap Block]

 e2_FADE_reallocate(0, 1);
 e2_FADE_setup(0, YES, YES, YES, 0, 3, offset_A, 0, 0, 0);
  e2_FADE_reallocate_frame(0, 3);
  e2_FADE_setup_frame(0, 0, YES, 512, 512, 512, 767, 767, 767,  1,  1,  1, 2, 1);
  e2_FADE_setup_frame(0, 1, YES, 767, 767, 767, 257, 257, 257, -1, -1, -1, 2, 1);
  e2_FADE_setup_frame(0, 2, YES, 257, 257, 257, 512, 512, 512,  1,  1,  1, 2, 1);
 slColOffsetOn(NBG1ON|NBG2ON|NBG3ON|RBG0ON|BACKON|SPRON);

 while(-1)
 {
  e2_FADE_animate(0);
  slSynch();
 }
}
